<section id="jobs_header" class="content-header"
  style="padding: 10px;background: white;margin: 15px;box-shadow: 0 2px 5px rgba(0, 0, 0, 0.1);">
  <div class="row">
    <div class="col-sm-4">
      <h1 style="margin:0px;font-size:19px">Jobs</h1>
      <small>Displaying all available jobs</small>
    </div>
    <div class="col-sm-8">
      <a [routerLink]="['/jobs/new']">
        <button kendoButton class="pull-right" primary="true" data-position='bottom'>
          <svg class="icon_change_log" shape-rendering="geometricPrecision" width="20" height="20">
            <use xlink:href="./assets/dist/img/icons.svg#icon_job"></use>
          </svg> &nbsp;New Job</button>
      </a>
      <a [routerLink]="['/bulk-load/new']">
        <button kendoButton class="pull-right" primary="true">
          <svg class="icon_change_log" shape-rendering="geometricPrecision" width="20" height="20">
            <use xlink:href="./assets/dist/img/icons.svg#icon_job"></use>
          </svg> &nbsp;New Bulk Job</button>
      </a>
      <button kendoButton class="pull-right" (click)="allClear()">
        All Clear</button>
      <button kendoButton class="pull-right" (click)="syncMetadata()">
        Sync Metadata</button>
    </div>
  </div>
</section>
<section id="jobs_body" class="content content-body">
  <kendo-grid [data]="jobGridDataResult" [height]="460" [filterable]="'menu'" [resizable]="true"
    (pageChange)="pageChangeJob($event)" [sortable]=" { allowUnsort: true}" [pageSize]="state.take" [skip]="state.skip"
    [sort]="state.sort" [filter]="state.filter" [sortable]="true"
    [pageable]="{info: info, type: type,buttonCount:buttonCount, pageSizes: jobPageSizes, previousNext: previousNext }"
    [loading]="jobGridLoading" (filterChange)="filterChange($event)" (dataStateChange)="dataStateChange($event)"
    (sortChange)="sortChangeConnection($event)" (cellClick)="cellClickHandler($event)">

    <kendo-grid-column field="action" title="" width="42" [filterable]="flase" [locked]="true">
      <ng-template kendoGridCellTemplate kendoTooltip let-dataItem>
          <span id="dotBtn">
  
          <button #anchor (click)="onToggle(dataItem)" class="k-button padding-0"
            style="border: 0px;background: transparent">
            <img src="/assets/dist/img/vertical-dot.png" alt="vertical-dot"  width="16px" />
          </button>
       </span>
       
          <span kendoTooltip position="right">

            <kendo-popup [anchor]="anchor" (anchorViewportLeave)="dataItem.toggle = false" *ngIf="dataItem.toggle">
              <ul class="nav nav-list">

                <li>
                  <a href="javascript:void(0)" routerLink="/jobs/{{dataItem.jobId}}" class="changelog white"
                    id="editJob">
                    <svg class="icon_update" shape-rendering="geometricPrecision" width="15" height="15">
                      <use xlink:href="./assets/dist/img/icons.svg#icon_update"></use>
                    </svg> Edit Job
                  </a>
                </li>

                <li>
                  <a href="javascript:void(0)" (click)="runJob(dataItem)" class="changelog white" id="runJob">
                    <svg class="icon_update" shape-rendering="geometricPrecision" width="15" height="15">
                      <use xlink:href="./assets/dist/img/icons.svg#icon_update"></use>
                    </svg> Run Job
                  </a>
                </li>
                <li>
                  <a href="javascript:void(0)" (click)="getAllAccountOfTreeitory(dataItem.territoryId)"
                    class="changelog white">
                    <svg class="icon_copy" shape-rendering="geometricPrecision" width="15" height="15">
                      <use xlink:href="./assets/dist/img/icons.svg#icon_copy"></use>
                    </svg> Clone Job
                  </a>
                </li>
                <li>
                <li>
                  <a (click)="exportJob(dataItem)" [href]="downloadJsonHref" download="download.json"
                    class="changelog white">
                    <svg class="icon_export" shape-rendering="geometricPrecision" width="15" height="15">
                      <use xlink:href="./assets/dist/img/icons.svg#icon_export"></use>
                    </svg> Export Job
                  </a>
                </li>
                <li>
                  <a href="javascript:void(0)" *ngIf="!openedLog" (click)="openLog(dataItem)">
                    <svg class="icon_change_log" shape-rendering="geometricPrecision" width="20" height="20">
                      <use xlink:href="./assets/dist/img/icons.svg#icon_change_log"></use>
                    </svg> View log
                  </a>
                </li>
                <li>
                  <a href="javascript:void(0)" (click)="removeJob(dataItem.jobId)" class="changelog white"
                    id="removeJob">
                    <svg class="icon_delete" shape-rendering="geometricPrecision" width="15" height="15">
                      <use xlink:href="./assets/dist/img/icons.svg#icon_delete"></use>
                    </svg> Remove Job
                  </a>
                </li>
              </ul>
            </kendo-popup>
          </span>
      </ng-template>
    </kendo-grid-column>
    <kendo-grid-column title="" width="48x"
      [style]="{'overflow': 'hidden','text-overflow': 'ellipsis', 'white-space': 'nowrap'}" [locked]="true">
      <ng-template kendoGridCellTemplate let-dataItem>
        <button #info (mouseover)='showInfo(dataItem)'
          [ngClass]="{'infoBtnDisabled': dataItem.viewJobDifferenceDetailsResponseList === undefined || dataItem?.viewJobDifferenceDetailsResponseList?.length === 0}"
          [disabled]="dataItem.viewJobDifferenceDetailsResponseList === undefined || dataItem?.viewJobDifferenceDetailsResponseList?.length === 0"
          class="k-button padding-0" style="border: 0px;background: transparent">
          <svg title="Stop Job" class="icon_connection" shape-rendering="geometricPrecision" width="20" height="20">
            <use xlink:href="./assets/dist/img/icons.svg#icon_info"></use>
          </svg>
        </button>
        <kendo-popup [anchor]="info" (anchorViewportLeave)="dataItem.toggleInfo = false" *ngIf="dataItem.toggleInfo">
          <div style="width: 200px; height: 100px; overflow: auto;">
            <table style="font-size: 10px">
              <tr *ngFor="let item of dataItem.viewJobDifferenceDetailsResponseList">
                <td>
                  {{item.fieldName}}
                </td>
                <td>
                  {{item.status}}
                </td>
              </tr>
            </table>
          </div>
        </kendo-popup>
      </ng-template>
    </kendo-grid-column>
    <!-- <kendo-grid-column title="" width="45x" [locked]="true"
    [style]="{'overflow': 'hidden','text-overflow': 'ellipsis', 'white-space': 'nowrap'}">
    <ng-template kendoGridCellTemplate let-dataItem>
        <input type="checkbox"/>
    </ng-template>
  </kendo-grid-column> -->
    <kendo-grid-column field="jobName" title="Job Name" class="kendo-cell" width="320"
      [style]="{'overflow': 'hidden','text-overflow': 'ellipsis', 'white-space': 'nowrap'}">
      <ng-template kendoGridFilterMenuTemplate let-filter let-column="column" let-filterService="filterService">
        <input kendoTextBox (input)="filterChangeConnection($event, filterService, 'jobName')" />
      </ng-template>
    </kendo-grid-column>

    <kendo-grid-column field="sourceConnectionName" title="Source Connection" width="150"
      [style]="{'overflow': 'hidden','text-overflow': 'ellipsis', 'white-space': 'nowrap'}" [filterable]="true">
      <ng-template kendoGridFilterMenuTemplate let-filter let-column="column" let-filterService="filterService">
        <kendo-dropdownlist [data]="connections" class="custom_dpd" height="40" [filterable]="true" [textField]="'name'"
          [valueField]="'name'" [(ngModel)]="jobFilter.sourceConnectionName" [value]="'name'" [valuePrimitive]="true"
          [valuePrimitive]="true" (valueChange)="DropDownFilterChange($event,filterService, 'sourceConnectionName')">
        </kendo-dropdownlist>
      </ng-template>
    </kendo-grid-column>

    <kendo-grid-column field="destinationConnectionName" title="Destination Connection" width="150"
      [style]="{'overflow': 'hidden','text-overflow': 'ellipsis', 'white-space': 'nowrap'}" [filterable]="true">
      <ng-template kendoGridFilterMenuTemplate let-filter let-column="column" let-filterService="filterService">
        <kendo-dropdownlist [data]="connections" class="custom_dpd" height="40" [filterable]="true" [textField]="'name'"
          [valueField]="'name'" [(ngModel)]="jobFilter.destinationConnectionName" [value]="'name'"
          [valuePrimitive]="true"
          (valueChange)="DropDownFilterChange($event,filterService, 'destinationConnectionName')">
        </kendo-dropdownlist>
      </ng-template>
    </kendo-grid-column>

    <kendo-grid-column field="status" title="Status" width="150"
      [style]="{'overflow': 'hidden','text-overflow': 'ellipsis', 'white-space': 'nowrap'}" [filterable]="true">
      <ng-template kendoGridFilterMenuTemplate let-filter let-column="column" let-filterService="filterService">
        <kendo-dropdownlist [data]="statusDropDownFilter" class="kendo-input" [filterable]="true"
          [defaultItem]="{ description: 'Status State', code: '0' }" [textField]="'description'" [valueField]="'code'"
          [valuePrimitive]="true" [value]="'code'" [(ngModel)]="jobFilter.status"
          (valueChange)="DropDownFilterChange($event, filterService,'status')">
        </kendo-dropdownlist>
      </ng-template>
    </kendo-grid-column>

    <kendo-grid-column field="state" title="Total Record Count" width="150"
      [style]="{'overflow': 'hidden','text-overflow': 'ellipsis', 'white-space': 'nowrap'}" [filterable]="false">
    </kendo-grid-column>
    <kendo-grid-column field="lastRun" title="Last Run (PST)" width="150"
      [style]="{'overflow': 'hidden','text-overflow': 'ellipsis', 'white-space': 'nowrap'}" [filterable]="false">
      <ng-template kendoGridFilterMenuTemplate let-filter let-column="column" let-filterService="filterService">
        <input kendoTextBox [value]="jobModal.destinationConnection"
          (input)="onInputFilterValue($event, filterService,'lastRun')" />
      </ng-template>
      <ng-template kendoGridCellTemplate let-dataItem>
        <span kendoTooltip position="left" title="{{dataItem.lastRun}}">
          {{dataItem.lastRun}}
        </span>
      </ng-template>
    </kendo-grid-column>

    <kendo-grid-column field="created" title="Created Date (PST)" width="150"
      [style]="{'overflow': 'hidden','text-overflow': 'ellipsis', 'white-space': 'nowrap'}" [filterable]="false">
      <ng-template kendoGridFilterMenuTemplate let-filter let-column="column" let-filterService="filterService">
        <input kendoTextBox [value]="jobModal.created" (input)="onInputFilterValue($event, filterService,'created')" />
      </ng-template>
      <ng-template kendoGridCellTemplate let-dataItem>
        <span kendoTooltip position="left" title="{{dataItem.created}}">
          {{dataItem.created}}
        </span>
      </ng-template>
    </kendo-grid-column>

    <kendo-grid-column field="updated" title="Updated Date (PST)" width="150"
      [style]="{'overflow': 'hidden','text-overflow': 'ellipsis', 'white-space': 'nowrap'}" [filterable]="false">
      <ng-template kendoGridFilterMenuTemplate let-filter let-column="column" let-filterService="filterService">
        <input kendoTextBox [value]="jobModal.updated" (input)="onInputFilterValue($event, filterService,'updated')" />
      </ng-template>
      <ng-template kendoGridCellTemplate let-dataItem>
        <span kendoTooltip position="left" title="{{dataItem.updated}}">
          {{dataItem.updated}}
        </span>
      </ng-template>
    </kendo-grid-column>

    <kendo-grid-column field="createdBy" title="Created By" width="150"
      [style]="{'overflow': 'hidden','text-overflow': 'ellipsis', 'white-space': 'nowrap'}" [filterable]="false">
      <ng-template kendoGridFilterMenuTemplate let-filter let-column="column" let-filterService="filterService">
        <input kendoTextBox [value]="jobModal.createdBy"
          (input)="onInputFilterValue($event, filterService,'createdBy')" />
      </ng-template>
      <ng-template kendoGridCellTemplate let-dataItem>
        <span kendoTooltip position="left" title="{{dataItem.createdBy}}">
          {{dataItem.createdBy}}
        </span>
      </ng-template>
    </kendo-grid-column>

    <kendo-grid-column field="updatedBy" title="Updated By" width="150"
      [style]="{'overflow': 'hidden','text-overflow': 'ellipsis', 'white-space': 'nowrap'}" [filterable]="false">
      <ng-template kendoGridFilterMenuTemplate let-filter let-column="column" let-filterService="filterService">
        <input kendoTextBox [value]="jobModal.updatedBy"
          (input)="onInputFilterValue($event, filterService,'updatedBy')" />
      </ng-template>
      <ng-template kendoGridCellTemplate let-dataItem>
        <span kendoTooltip position="left" title="{{dataItem.updatedBy}}">
          {{dataItem.updatedBy}}
        </span>
      </ng-template>
    </kendo-grid-column>

  </kendo-grid>
  <kendo-dialog title="View Log" *ngIf="isOpenedLog" (close)="close('cancel')" [minWidth]="800" [width]="1000">
    <app-log [job]="job"></app-log>
  </kendo-dialog>
</section>